<?php

namespace Helpie\Features\Components\Frontend_Editor;

use \Helpie\Includes\Translations as Translations;

// include_once HELPIE_PLUGIN_PATH . 'includes/utils/test-helpers.php';

if (!class_exists('\Helpie\Features\Components\Frontend_Editor\Editor_Controller')) {
    class Editor_Controller
    {
        public $controls;

        public function __construct()
        {
            $this->model = new \Helpie\Features\Components\Frontend_Editor\Editor_Model();
            $this->view = new \Helpie\Features\Components\Frontend_Editor\Editor_View($this->model);
            $this->controls = new \Helpie\Features\Components\Frontend_Editor\Views\Controls();
        }

        public function get_view($args = array())
        {

            // Required
            $viewProps = $this->model->get_viewProps($args);
            $collectionProps = $viewProps['collection'];
            $post_id = $collectionProps['post_id'];
            $dynamic_caps = new \Helpie\Features\Services\Dynamic_Caps\Dynamic_Caps();

            $can_user_modify_any_topic = $dynamic_caps->can_user_modify_any_topic();
            $can_modify_article = $dynamic_caps->can_user_modify_this_post($post_id);

            // Final permission equation
            $can_modify_article = $can_modify_article || $can_user_modify_any_topic;

            $html = "<div class='helpie-edit-page-container'>";

            if ($can_modify_article) {
                $html .= $this->view->get($viewProps);
            } else {
                $html .= Translations::get('dont_have_access_to_edit');
            }

            $html .= "</div>";

            return $html;
        }

        /* PROTECTED */

        protected function can_access_editor($collectionProps)
        {

            $can_edit = ($collectionProps['can_edit'] == true);
            $can_publish = ($collectionProps['can_publish'] == true);
            $can_approve = ($collectionProps['can_approve'] == true);

            if ($can_edit || $can_publish || $can_approve) {
                return true;
            }

            return false;
        }
    } // END CLASS
}
