<?php
namespace Helpie\Features\Components\Toc\Model;

use \Helpie\Includes\Translations as Translations;

if (!defined('ABSPATH')) {
    exit;
} // Exit if accessed directly

if (!class_exists('\Helpie\Features\Components\Toc\Model\Style_Config_Model')) {
    class Style_Config_Model
    {
        public function get_config()
        {
            $style_config = array(
                'collection' => array(
                    'name' => 'helpie_toc',
                    'selector' => '.helpie-toc',
                    'label' => Translations::get('toc'),
                    'styleProps' => array('background', 'border', 'padding', 'margin'),
                ),
                'title' => array(
                    'name' => 'helpie_toc_title',
                    'selector' => '.helpie-toc .collection-title',
                    'label' => Translations::get('title'),
                    'styleProps' => array('background', 'color', 'typography', 'text-align', 'border', 'padding', 'margin'),
                ),

                'element' => array(
                    'name' => 'helpie_element',
                    'selector' => '.helpie-toc .helpie-element',
                    'label' => Translations::get('single_item'),
                    'styleProps' => array('background', 'border', 'padding', 'margin'),
                    'children' => array(
                        'title' => array(
                            'name' => 'helpie_element_title',
                            'selector' => '.helpie-toc  .helpie-element .item-title a',
                            'label' => Translations::get('single_item_title'),
                            'styleProps' => array('color', 'typography', 'border'),
                        ),
                    ),
                ),

            );

            return $style_config;
        }
    }
}
