<?php

namespace Helpie\Includes\Core\Envato\Views;

use \Helpie\Includes\Translations as Translations;

if (!defined('ABSPATH')) {
    exit;
}
// Exit if accessed directly

if (!class_exists('\Helpie\Includes\Core\Envato\Views\Activation_View')) {

    class Activation_View
    {

        public function __construct($envato_model)
        {
            $this->model = $envato_model;
        }

        public function get_view()
        {

            $html = '';

            $html .= "<div class='ui segment helpie-segment plugin-activation'>";
            $html .= "<div class='content'>";
            $html .= "<h3 class='ui dividing header'>" . Translations::get('plugin_activation') . "</h3>";

            if ($this->model->get_purchase_code()) {
                $html .= $this->purchase_code_register_panel();
            } else {

                $html .= $this->no_purchase_code_register_panel();
            }

            $html .= "</div>";
            $html .= "</div>";

            return $html;

        }

        protected function purchase_code_register_panel()
        {
            $html = "";

            $html .= "<div class='ui very relaxed divided list'>";

            $html .= "<div class='item'>";
            $html .= "<i class='large archive middle aligned icon'></i>";
            $html .= "<div class='content'>";
            $html .= "<a class='header'>" . Translations::get('purchase_code') . "</a>";
            $html .= "<div class='description'><p><div class='ui message'>" . $this->model->get_purchase_code() . "</div></p></div>";
            $html .= "</div>";
            $html .= "</div>";

            $html .= $this->get_support_item_html();

            $html .= "</div>";

            return $html;

        }

        protected function no_purchase_code_register_panel()
        {

            $personal_token_doc = 'http://helpiewp.com/docs/home/updating-the-plugin/';
            $html = "<div class='description'>";
            $html .= '<input name="helpie_envato_api_token" type="text" class="tomb-text" style="width:320px" value="' . $this->model->get_envato_api_token() . '" placeholder="' . Translations::get('enter_envato_personal_token') . '">';

            $html .= '<h3>' . Translations::get('enter_personal_token_to_get_updates') . '</h3>';
            $html .= '<p>' . Translations::get('oauth_envato_protocol') . '</p>';
            $html .= '<p><a target="_blank" href="' . $personal_token_doc . '"><button class="ui basic button">' . Translations::get('create_personal_token') . '</button></a></p>';
            $html .= '<p><button id="helpie-save-envato-api-token" class="ui primary button tg-button tg-button-register-token">' . Translations::get('save_changes') . '</button><div class="spinner"></div><strong></strong></p>';
            $html .= "</div>";

            return $html;
        }

        protected function get_support_item_html()
        {
            if ($this->model->get_supported_until() > 0) {
                $html = "<div class='item'>";
                $html .= "<i class='large life ring middle aligned icon'></i>";
                $html .= "<div class='content'>";
                $html .= "<a class='header'>" . Translations::get('premium_ticket_support') . ' (' . $this->model->get_supported_until() . ' ' . Translations::get('days_left') . ")</a>";

                $html .= "<div class='description'>";
                $html .= "<p>" . Translations::get('get_help_from_support_team') . "</p>";
                $html .= "<p>";
                $html .= "<a class='tg-button' target='_blank' href='http://helpie.pauple.com/docs'>";
                $html .= "<button class='ui primary button'>" . Translations::get('get_support') . "</button>";
                $html .= "</a>";
                $html .= "</p>";
                $html .= "</div>";

                $html .= "</div>";
                $html .= "</div>";
            } else {
                $html = "<div class='item'>";
                $html .= "<i class='large life ring middle aligned icon'></i>";
                $html .= "<div class='content'>";
                $html .= "<a class='header'>" . Translations::get('expired_premium_ticket_support') . "</a>";

                $html .= "<div class='description'>";
                $html .= "<p>" . Translations::get('get_help_from_support_team') . "</p>";
                $html .= "<p>";
                $html .= "<a class='tg-button' target='_blank' href='https://codecanyon.net/item/helpie-helpdesk-documentation-wordpress-plugin/18882940'>";
                $html .= "<button class='ui primary button'>";
                $html .= Translations::get('extend_support');
                $html .= '</button>';
                $html .= "</a>";
                $html .= "</a></p>";
                $html .= "</div>";

                $html .= "</div>";
                $html .= "</div>";
            }

            return $html;
        }

    } // END CLASS
}
