<?php
use \Helpie\Includes\Translations as Translations;

// error_log('functions.php');
global $helpie_kb_all_topics;
global $helpie_kb_get_term_query_index;
$helpie_kb_get_term_query_index = 0;

function set_all_helpie_kb_topics()
{
    global $helpie_kb_all_topics;
    $helpie_kb_all_topics = get_terms('helpdesk_category');
}

function get_all_helpie_kb_topics()
{
    global $helpie_kb_all_topics;

    // error_log('$helpie_kb_all_topics : ' . print_r($helpie_kb_all_topics, true));
    return $helpie_kb_all_topics;
}

/* Filter Executers */

function helpie_kb_the_content($content)
{
    $post_type = 'pauple_helpie';

    global $post;
    if (isset($post->post_type) && $post->post_type == $post_type) {
        $content = apply_filters('helpie_kb_the_content', $content);
    }

    return $content;
}

function helpie_kb_filter_posts($query)
{

    $post_type = 'pauple_helpie';
    // $is_allowed_query = ($query->is_main_query() || $query->is_search());
    $is_single = $query->is_single();
    $is_helpie_cpt = in_array($query->get('post_type'), array($post_type));
    if ($is_helpie_cpt && !$is_single) {
        // error_log('filter_helpie_posts');
        do_action('helpie_kb_filter_posts', $query);
    }
}

function bool2str($bool)
{
    if ($bool === false) {
        return 'FALSE';
    } else {
        return 'TRUE';
    }
}

function helpie_kb_get_terms($terms, $taxonomies, $args, $term_query)
{
    // error_log('helpie_kb_get_terms');
    // error_log('$terms : ' . print_r($terms, true));
    return apply_filters('helpie_kb_get_terms', $terms, $taxonomies, $args, $term_query);
}

function helpie_kb_pre_get_terms($query_loc)
{
    global $helpie_kb_get_term_query_index;

    remove_action('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 3); // Remove action for this specific get_term_children()
    $is_helpie_tax_page = is_tax('helpdesk_category');
    add_action('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 3); // Add action to reset original filter
    $helpie_kb_get_term_query_index++;

    if (!is_object($query_loc) || !property_exists($query_loc, 'query_vars') || ($is_helpie_tax_page && $helpie_kb_get_term_query_index == 1)) {
        return;
    }

    $is_helpie_tax = (isset($query_loc->query_vars['taxonomy']) && in_array('helpdesk_category', $query_loc->query_vars['taxonomy']));

    if ($is_helpie_tax) {
        do_action('helpie_kb_pre_get_terms', $query_loc);
    }
}

function helpie_call_function_without_filters($methodName, $method_arguments, $options = [])
{

    // remove_action('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 3); // Remove action for this specific function()
    remove_action('pre_get_posts', 'helpie_kb_filter_posts');
    remove_filter('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 4); // Remove action for this specific get_term_children()

    if (isset($options['obj'])) {
        // $result = call_user_func_array($methodName, $method_arguments);
    } else {
        $result = call_user_func_array($methodName, $method_arguments);
    }

    // add_action('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 3); // Add action to reset original filter
    add_action('pre_get_posts', 'helpie_kb_filter_posts');
    add_filter('pre_get_terms', 'helpie_kb_pre_get_terms', 10, 4); // Add action to reset original filter

    return $result;
}

// function helpie_kb_pre_get_terms($args, $taxonomies)
// {
//     $category = 'helpdesk_category';

//     if (!in_array($category, $taxonomies)) {
//         return $args;
//     }

//     $args = apply_filters('helpie_kb_pre_get_terms', $args, $taxonomies);
//     return $args;
// }

/* Getters*/

function get_helpie_kb_articles($args = array())
{

    // error_log('get_helpie_kb_articles');
    // error_log('$args : ' . print_r($args, true));
    $articles_model = new \Helpie\Features\Domain\Query\Articles_Model();
    $articles = $articles_model->get_articles($args);

    return $articles;
}

if (!function_exists('csf_get_all_helpie_kb_topics')) {
    function csf_get_all_helpie_kb_topics()
    {
        $options = ['all' => Translations::get('all')];
        $topics = get_all_helpie_kb_topics();

        if (!empty($topics)) {
            foreach ($topics as $key => $value) {
                $options[$value->term_id] = $value->name;
            }
        }
        return $options;
    }
}

if (!function_exists('csf_get_all_helpie_kb_mp_topics')) {
    function csf_get_all_helpie_kb_mp_topics()
    {
        $options = ['all' => Translations::get('all')];
        $topics = get_all_helpie_kb_topics();

        if (!empty($topics)) {
            foreach ($topics as $key => $value) {
                if ($value->parent == 0) {
                    $options[$value->term_id] = $value->name;
                }
            }
        }
        return $options;
    }
}

/* Core Helpie Functions */
function get_helpie_kb_capabilities($location = 'single', $wp_obj = null)
{
    $access_controller = new \Helpie\Features\Services\Access_Control\Controller();
    $dynamic_caps = $access_controller->get_dynamic_capabilities($location, $wp_obj);

    // error_log('$dynamic_caps : ' . print_r($dynamic_caps, true));
    return $dynamic_caps;
}

function get_helpie_header()
{
    $headerName = apply_filters('helpie_kb_header', '');
    return get_header($headerName);
}

/* Protected */

// For WPUnit Testing Only
function remove_get_terms_filter()
{
    remove_filter('get_terms', 'helpie_kb_get_terms', 10, 4);
    // error_log('remove_get_terms_filter');
    define('HELPIE_TERM_FILTER', 'OFF');
}
/*
TODO: Envato registered user only can access premium code
 */

function helpie_kb_can_use_premium_code()
{
    $is_plugin_from_enavato = HELPIE_KB_VENDOR == 'envato' ? true : false;
    $is_plugin_from_freemius = HELPIE_KB_VENDOR == 'freemius' && hk_fs()->can_use_premium_code() ? true : false;
    $eithor_one_is_active = $is_plugin_from_enavato || $is_plugin_from_freemius ? true : false;
    $can_use_premium_code = $eithor_one_is_active ? true : false;

    return $can_use_premium_code;
}
